# Define your item pipelines here
#
# Don't forget to add your pipeline to the ITEM_PIPELINES setting
# See: https://docs.scrapy.org/en/latest/topics/item-pipeline.html


# useful for handling different item types with a single interface
import pymysql as pymysql

import souhcars.items


class SouhcarsPipeline:
    def __init__(self):
        self.host = "47.100.68.39"
        self.port = 3310
        self.database = "db_spider"
        self.user = "root"
        self.password = "dip-test"
        self.con = pymysql.connect(host=self.host, port=self.port, database=self.database, user=self.user,
                                   password=self.password)
        self.cu = self.con.cursor()
        print("实例化了数据库")

    def process_item(self, item, spider):
        if isinstance(item, souhcars.items.BrandItem):
            sql_q = 'select id from t_brand_souh where brand_id = "{}"'.format(item['brand_id'])
            sql = 'insert into t_brand_souh (brand_id, brand_name) values ("{}","{}")' \
                .format(item['brand_id'], item['brand_name'])
            self.con.ping(reconnect=True)
            self.cu.execute(sql_q)
            if str(self.cu.fetchone()) != 'None':
                return
            self.cu.execute(sql)
            self.con.commit()

        elif isinstance(item, souhcars.items.SeriesItem):
            sql_q = 'select id from t_series_souh where series_id = "{}"'.format(item['series_id'])
            sql = 'insert into t_series_souh (brand_id, maker_id, maker_name, series_id, series_name)' \
                  ' values ("{}","{}","{}","{}","{}")'.format(item['brand_id'], item['maker_id'], item['maker_name'],
                                                              item['series_id'], item['series_name'])
            self.con.ping(reconnect=True)
            self.cu.execute(sql_q)
            if str(self.cu.fetchone()) != 'None':
                return
            self.cu.execute(sql)
            self.con.commit()

        elif isinstance(item, souhcars.items.StyleItem):
            sql_q = 'select id from t_style_souh where style_id = "{}"'.format(item['style_id'])
            sql = 'insert into t_style_souh (series_id, style_id, style_name, conf)' \
                  ' values ("{}","{}","{}","{}")'.format(item['series_id'], item['style_id'], item['style_name'],
                                                         item['conf'])
            self.con.ping(reconnect=True)
            self.cu.execute(sql_q)
            if str(self.cu.fetchone()) != 'None':
                return
            self.cu.execute(sql)
            self.con.commit()

    def __del__(self):
        self.cu.close()
        self.con.close()
